Raspberry Pi - Support #408

Installing Drivers for TL-WN725N v2 on Raspberry Pi
06/20/2014 11:18 AM - Daniel Curtis

Status: Closed Start date: 06/20/2014
Priority: High Due date:

Assignee: Daniel Curtis % Done: 100%
Category: Wireless Support Estimated time: 0.50 hour
Target version: Spent time: 6.00 hours
Description

Precompiled method

Driver files available for the TP-LINK TL-WN725N V2 and similar wifi dongles using the 8188eu driver module for systems using the
Raspbian image.

IMPORTANT: First check the version of Linux you have. Use the command uname -a to find the version of Linux.

uname -—a
Linux raspberrypi 3.10.24+ #614 PREEMPT Thu Dec 19 20:38:42 GMT 2013 armv6l GNU/Linux

The important part is 3.10.24+ #614. This is just an example and your version may be different. Select the right driver for the version
you have from the list below.

rtI8188eu drivers for 3.6.11+

e 3.6.11+ #371 up to #520 inclusive - 8188eu-20130209.tar.gz
o 3.6.11+ #524, #528, #532 - 8188eu-20130815.tar.gz
e 3.6.11+ #538, #541, #545, #551, #557 - 8188eu-20130830.tar.gz

rtI8188eu drivers for 3.10.18+ to 3.10.38+

3.10.18+ #577 - 8188eu-20131105.tar.gz
3.10.18+ #579, #585 - 8188eu-20131106.tar.gz
3.10.18+ #587 - 8188eu-20131110.tar.gz
3.10.18+ #590, #592 - 8188eu-20131111.tar.gz
3.10.18+ #594, #596 - 8188eu-20131113.tar.gz
3.10.19+ #600 - 8188eu-20131113.tar.gz
3.10.21+ #602, #604 - 8188eu-20131113.tar.gz
3.10.22+ #606 - 8188eu-20131206.tar.gz
3.10.23+ #608 - 8188eu-20131209.tar.gz

3.10.24+ #610 - 8188eu-20131209.tar.gz
3.10.24+ #614 - 8188eu-20131219.tar.gz
3.10.25+ #616, #618 - 8188eu-20131219.tar.gz
3.10.25+ #622, #624 - 8188eu-20131219.tar.gz
3.10.26+ #628 - 8188eu-20140110.tar.gz
3.10.27+ #630 - 8188eu-20140117.tar.gz
3.10.28+ #632, #634 - 8188eu-20140117.tar.gz
3.10.29+ #636, #638 - 8188eu-20140117.tar.gz
3.10.30+ #640, #642 - 8188eu-20140117.tar.gz
3.10.32+ #646, #648 - 8188eu-20140117.tar.gz
3.10.33+ #654, #656 - 8188eu-20140117.tar.gz
3.10.33+ #658 - 8188eu-20140117.tar.gz
3.10.34+ #660, #661 - 8188eu-20140117.tar.gz
3.10.36+ #662, #664 - 8188eu-20140117.tar.gz
3.10.36+ #665, #666 - 8188eu-20140117.tar.gz
3.10.37+ #667, #669 - 8188eu-20140117.tar.gz
3.10.38+ #675 - 8188eu-20140117.tar.gz
rti8188eu drivers for 3.12.18+ to 3.12.22+
3.12.18+ #673, #677 - 8188eu-20140425.tar.gz
3.12.18+ #679, #680 - 8188eu-20140501.tar.gz
3.12.19+ #681, #682 - 8188eu-20140509.tar.gz
3.12.19+ #684 - 8188eu-20140509.tar.gz

3.12.20+ #685, #686 - 8188eu-20140509.tar.gz
3.12.20+ #687 - 8188eu-20140509.tar.gz

3.12.21+ #688, #689 - 8188eu-20140509.tar.gz
3.12.22+ #690, #691 - 8188eu-20140616.tar.gz

[

Link to driver files - use date code from list above to download required driver
https://dl.dropboxusercontent.com/u/80256631/8188eu-201xyyzz.tar.gz

NOTE: If updating firmware revisions, say from 3.10.23+ to 3.10.24+, and they use the same driver, in this case
8188eu-20131209.tar.gz, you will still need to reinstall the driver on the newer version of Linux, even though the driver has not
changed as it will be loaded from a different directory by the new Linux revision and you need to install it in the new directory.

The driver installation instructions expect you to be using Raspbian, either installed from a basic rasbian image or installed using
NOOBS. The instructions are based on running from a Command Line Terminal, not a GUI (Graphical User Interface). If you are
running using the GUI you will need to open a terminal window and run the commands from the terminal window but | can't
guarantee they will work.

If you have a wired internet connection install the driver with the following commands

wget https://dl.dropboxusercontent.com/u/80256631/8188eu-201lxyyzz.tar.gz <--set data code for driv
er version above

tar -zxvf 8188eu-20lxyyzz.tar.gz <--set data code for driv
er version above

sudo install -p -m 644 8188eu.ko /lib/modules/$ (uname -r)/kernel/drivers/net/wireless

sudo insmod /lib/modules/$ (uname -r)/kernel/drivers/net/wireless/8188eu.ko

sudo depmod -a

If you do not have an internet connection the driver file will need to be downloaded on another computer and copied to the SD card. |
use a Windows laptop and will use that as an example of how to copy and install the wifi driver.

Open a web browser on your Windows computer and download the driver. Check the name of the driver file before saving it and
correct it if necessary. | have sometimes found Windows tries to save the driver file as 8188eu-201xyyzz.tar.tar when it should be
8188eu-201xyyzz.tar.gz. Substitute the correct file name for "xyyzz".

Take the SD card and load it into an SD card reader on your Windows computer. Copy the driver file, 8188eu-201xyyzz.tar.gz, from

your Windows computer to the SD card. Safely remove the SD card from the card reader by clicking the safe removal icon in the task
bar and install the SD card in your Raspberry Pi and power on and login.

Compiling from Source

Compiling with DKMS on Raspbian (recommended)

o |nstall dkms:
apt-get install dkms
e Get the current raspberry pi linux source:

cd /usr/src

git clone --depth 1 https://github.com/raspberrypi/linux.git linux-'uname -r°
cd linux

zcat /proc/config.gz > .config

o In the next step you may be prompted questions about the configuration if your /proc/config.gz does not answer them (new
features for example)
sudo make oldconfig

sudo make modules_prepare

sudo wget https://github.com/raspberrypi/firmware/blob/53d1lae311226b5cd7eal277832139b74b2b
b0f90/extra/Module.symvers

sudo 1ln -s /usr/src/linux-"uname -r' /lib/modules/ uname -r'/source

sudo 1ln -s /usr/src/linux-"uname -r' /lib/modules/ uname -r'/build

NOTE: | needed to use the History feature on GitHub to locate the exact version | was using, in this case it was 3.12.28+

e Get driver source

cd /usr/src
git clone https://github.com/lwfinger/rt18188eu.git

® Build and install the rtl8188eu driver using dkms:

dkms add ./rt8188eu
dkms build 8188eu/1.0
dkms install 8188eu/1.0

NOTE: | have had more trouble compiling on Raspbian than Arch, since their packages are kept more up to date.
Compiling with DKMS on Arch (recommended)

e Install DKMS and Linux headers

pacman -S dkms linux-raspberrypi-headers git

e Get driver source, compile, install and load it

cd /usr/src
git clone https://github.com/lwfinger/rt18188eu.git

e Build, install, and load the rtl8188eu driver:

dkms add ./rt8188eu
dkms build 8188eu/1.0
dkms install 8188eu/1.0

e Check that the driver was installed correctly by looking for a new network interface:

ip link

Install from AUR on Arch
e |nstall yaourt

¢ Install the dkms-8188eu package from the AUR:

yaourt dkms—-8188eu

o NOTE: Yes, that is the whole process. Isn't the AUR wonderful?
Manual compilation (not recommended)

e Get linux source code, prepare config files and create symlinks

cd /usr/src

git clone https://github.com/raspberrypi/linux.git
cd linux

zcat /proc/config.gz > .config

o In the next step you may be prompted questions about the configuration if your /proc/config.gz does not answer them (new
features for example)

sudo make oldconfig

sudo make modules_prepare

sudo wget https://github.com/raspberrypi/firmware/raw/master/extra/Module.symvers
sudo 1ln -s /usr/src/linux /lib/modules/ uname -r'/source

sudo 1ln -s /usr/src/linux /lib/modules/ uname -r  /build

e Get driver source, compile, install and load it

cd /usr/src

git clone https://github.com/lwfinger/rt18188eu.git
cd rtl8188eu

make all

sudo make install

After this step you should have those new files installed:

1. /lib/modules/"uname -r’/kernel/drivers/net/wireless/8188eu.ko
2. /lib/firmware/rtiwifi/rtl8188eufw.bin

e [ oad the module

sudo modprobe 8188eu

e Remove driver and linux source code to recover some space (around 700MB); do not run if you want to keep the code for future
compilations

cd /usr/src
rm /lib/modules/ uname -r' /source
rm /lib/modules/ uname -r' /build
rm /usr/src/linux-"uname -r’
rm /usr/src/linux
rm —-R rtl18188eu

Automagic compilation

e Script form:

vi compile_rtl18188eu.sh

o And add the followingL

#!/bin/bash
# Get linux source code, prepare config files and create symlinks

VERSION="uname -r | awk -F'.' '{print $1"."$2}"'"

gel =

wget https://codeload.github.com/raspberrypi/linux/tar.gz/rpi-${VERSION}.y -O rpi-${VERSIO
N}.y.tar.gz

sudo tar zxf rpi-${VERSION}.y.tar.gz —-C /usr/src/

cd /usr/src/linux-rpi-${VERSION}.y/

sudo bash -c "zcat /proc/config.gz > /usr/src/linux-rpi-${VERSION}.y/.config"

# In the next step you may be prompted questions about the configuration

# if your /proc/config.gz does not answer them (new features for example)

sudo make oldconfig

sudo make modules_prepare

sudo wget https://github.com/raspberrypi/firmware/raw/master/extra/Module.symvers
sudo 1ln -s /usr/src/linux-rpi-${VERSION}.y /lib/modules/ uname -r /source

sudo 1ln -s /usr/src/linux-rpi-${VERSION}.y /lib/modules/ uname -r  /build

# Optional

#sudo 1ln -s /usr/src/linux-rpi-${VERSION}.y /usr/src/linux- uname -r°

#sudo 1ln -s /usr/src/linux-rpi-${VERSION}.y /usr/src/linux

# Get driver source, compile, install and load it

cd ~

git clone https://github.com/lwfinger/rtl18188eu.git

cd rtl18188eu

# This will take around 20 minutes

make all

sudo make install

# After this step you should have those new files installed:
# /lib/modules/ uname -r' /kernel/drivers/net/wireless/8188eu.ko
# /lib/firmware/rtlwifi/rtl18188eufw.bin

sudo modprobe 8188eu

# Remove driver and linux source code to recover some space (around 700MB)

# Leave those lines commented if you want to keep the code for future compilations
#sudo rm /lib/modules/ uname -r' /source

#sudo rm /lib/modules/ uname -r  /build

#sudo rm /usr/src/linux-"uname -r°

#sudo rm /usr/src/linux

#sudo rm -R /usr/src/linux-rpi-${VERSION}.y

#cd ~

#rm rpi-${VERSION}.y.tar.gz

#rm —-R rtl1l8188eu

* Make the script executable:

chmod +x compile_rtl18188eu.sh

® Run the script:

./compile_rtl18188eu.sh

Resources

e hitp://www.raspberrypi.org/forums/viewtopic.php?p=462982
¢ http://tech.enekochan.com/en/2014/03/08/new-script-to-compile-tp-link-tl-wn725n-version-2-lwfinger-driver-in-raspbian/
e https://github.com/Ilwfinger/rtI8188eu

History

#1 - 06/20/2014 12:02 PM - Daniel Curtis
- File 8188eu-20131219.tar.gz added
- File 8188eu-20140616.tar.gz added

04/20/2024 5/8



http://www.raspberrypi.org/forums/viewtopic.php?p=462982
- Tracker changed from Bug to Support

- Description updated

#2 - 11/25/2014 03:58 PM - Daniel Curtis

- Description updated

#3 - 11/26/2014 05:08 PM - Daniel Curtis

- Description updated

#4 - 11/26/2014 05:54 PM - Daniel Curtis

# Compile driver for 3.10.y version of kernel. To compile for an older version you will need
# to set up the correct commits of linux and firmware to comply with the version of linux you
# need the driver for.

# Compiles 8188eu driver for 3.10.y without needing to compile the whole linux kernel. Requires
# driver firmware, rtl8188eufw.bin, which can be found in the driver source tree.

# Initialise kernel and driver source code for the first time for compiling drivers

# jump to home directory - /home/pi
cd

# make directory to hold source data
mkdir src

# enter source directory - /home/pi/src
cd src

# clone rtl8188eu source code repository — this will automatically generate a
# directory "rtl8188eu" at /home/pi/src/rtl8188eu.
git clone git://github.com/lwfinger/rt18188eu.git

clone Raspberry Pi firmware repository - this will automatically generate a
directory "firmware" at /home/pi/src/firmware - setting depth avoids downloading
the whole repository but allows reverting to some previous revisions if necessary.
Do not use git clone if it has already been used - use git pull to update the code.
git clone --depth 10 git://github.com/raspberrypi/firmware.git

HH H o

clone Raspberry Pi linux source code - this will automatically generate a
directory "linux" at /home/pi/src/linux - setting depth avoids downloading
the whole repository but allows reverting to some previous revisions if
necessary. Do not use git clone if it has already been used - use git pull
to update the code.

git clone --depth 235 git:github.com/raspberrypi/linux.git

HH H H I

# Updating source code for compiling drivers if code is already installed and
# newer code is available

# if rtl8188eu directory has already been generated it can be update with the

# latest code using git pull. enter rtl8188eu directory, run command then revert
# back to src directory

cd rtl81l88eu

git pull

cd ../

if firmware directory has already been generated it can be update with the
latest code using git pull enter firmware directory, run command then revert
back to src directory. Use depth option or git pull may load the whole of
the repository from way back 2011 or whenever

cd firmware

git pull --depth 2

cd ../

HH H o

if linux directory has already been generated it can be update with the latest
code using git pull. enter linux directory, run command then revert back to

src directory. Use depth option or git pull may load the whole of the repository
from way back 2011 or whenever ~ 3 Million+ files

cd linux

git pull --depth 2

cd ../

HH o H H
# Select a specific version of linux/firmware to compile driver for if required

adjust firmware version required for kernel version driver is to be used with
view commit ID's at https://github.com/raspberrypi/firmware/commits/master

HH o H

not required if driver is being compiled for most recent version kernel
# unless it has previously been set to use an older version of code

cd firmware

git checkout "branch"

git checkout "commit ID"

cd ../

enter linux source directory and adjust linux code version to use
adjust to version required for kernel version driver is to be used with
view commit ID's at https://github.com/raspberrypi/linux/commits/

not required if driver being compiled for most recent version kernel

cd linux

HH H o

git checkout "branch"
git checkout "commit ID"
cd ../

# To compile for latest code I use the following commands

# enter linux source directory
cd linux

# clean linux source directory tree
make mrproper

# generate .config using bcmrpi_defconfig which can be used to make .config for any

# version of linux without requiring to copying .config from a working version of code
# as suggested in many tutorials making life a little easier.

make bcmrpi_defconfig

# prepare source for module compile
make modules_prepare

# copy Module.symvers file from firmware tree to linux directory
cp ../firmware/extra/Module.symvers

# enter 8188eu driver source directory
cd ../rtl8188eu

# clean rtl8188eu source directory tree
make clean

# compile driver file 8188eu.ko
CONFIG_RTL8188EU=m make -C /home/pi/src/linux M= pwd’

# Install the driver

# install driver firmware if not already installed, install driver and reboot
sudo cp rtl8188eufw.bin /lib/firmware/rtlwifi
sudo install -p -m 644 8188eu.ko /lib/modules/$ (uname -r)/kernel/drivers/net/wireless

# insmod command should run without any error response if driver module is compiled OK
sudo insmod /lib/modules/$ (uname -r)/kernel/drivers/net/wireless/8188eu.ko

sudo depmod -a

sudo reboot

Hope this makes sense

#5 - 12/15/2014 12:27 PM - Daniel Curtis
- Description updated
- Priority changed from Normal to High

#6 - 12/15/2014 01:26 PM - Daniel Curtis

- Description updated
#7 - 12/15/2014 01:43 PM - Daniel Curtis

- Description updated

#8 - 12/15/2014 04:28 PM - Daniel Curtis

- Description updated

#9 - 12/31/2014 09:59 AM - Daniel Curtis

- Subject changed from Installing Drivers for TL-WN725N V2 on Raspbian to Installing Drivers for TL-WN725N v2 on Raspberry Pi

- Description updated

#10 - 12/31/2014 10:18 AM - Daniel Curtis
- Description updated
- Status changed from In Progress to Resolved

- % Done changed from 90 to 100

#11 - 05/01/2015 02:45 PM - Daniel Curtis
- Description updated

- Category set to Wireless Support

#12 - 05/10/2015 08:32 AM - Daniel Curtis

- Description updated

#13 - 05/10/2015 09:18 AM - Daniel Curtis

- Status changed from Resolved to Closed

#14 - 07/15/2016 07:47 PM - Daniel Curtis

- Description updated

Files

8188eu-20131219.tar.gz 294 KB 06/20/2014 Daniel Curtis

8188eu-20140616.tar.gz 293 KB 06/20/2014 Daniel Curtis
